#include <vector>
#include <iostream>
#include <set>
#include <fstream>

#define REP(i, n) for(int i = 0; i < n; i++)

using namespace std;


int two_valuation(int x){
	if(x <= 0)return -1;
	int ret = 1;
	while(0 == (x % (ret*2)))ret*=2;
	return ret;
}


int main(int argc, char ** argv){
	vector<string> args(argv+1, argv+argc);

	ifstream input, solution, contestant;
	input.open(args[0]);
	solution.open(args[1]);
	contestant.open(args[2]);

	// JAK SE CHOVAT, KDYZ SE NEJAKEJ SOUBOR NEPODARI OTEVRIT NEBO TAK?
	if(!input.good() || !solution.good() || !contestant.good()){
		cerr << "ERROR: Grader failed to open input files. Contact technical support." << endl;
		return 2;
	}

	set<int> nums;

	int n, a;
	input >> n;
	REP(i, n){
		input >> a;
		nums.insert(a);
	}

	int opt=(1<<30)-1, sol_n;
	solution >> sol_n;
	REP(i, sol_n){
		solution >> a;
		opt &= a;
	}
	opt = two_valuation(opt); // setrime misto

	int contestant_val = (1<<30)-1, contestant_n;
	contestant >> contestant_n;
	if(contestant_n < 1){
		cerr << "Musite vypsat alespon jedno cislo." << endl;
		cout << 0.0 << endl;
		return 0;
	}
	REP(i, contestant_n){
		if(!(contestant >> a)){
			cerr << "Spatny format odpovedi" << endl;
			cout << 0.0 << endl;
			return 0;
		}
		if(nums.find(a) == nums.end()){
			cerr << "Spatna odpoved" << endl;
			cout << 0.0 << endl;
			return 0;
		}
		nums.erase(a);
		contestant_val &= a;
	}
	contestant_val = two_valuation(contestant_val);

	if(contestant_val != opt){
		cerr << "Spatna odpoved" << endl;
		cout << 0.0 << endl;
	} else{
		cerr << "OK" << endl;
		cout << 1.0 << endl;
	}

	return 0;
}