#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;

const int LOGMAX = 30; // 2^30 > 10^9

int main(void) {
    int n;
    scanf("%d", &n);
    vector<int> a(n);
    for (int &x : a) cin >> x;

    // Do negace[i][j] vlozime libovolne cislo ze vstupu, ktere ma na i-te
    // pozici jednicku a na j-te pozici nulu. Pokud takove cislo neexistuje,
    // ponechame negace[i][j] = 0.
    vector<vector<int>> negace(LOGMAX + 1, vector<int>(LOGMAX + 1));
    for (int x : a) {
        for (int i = 0; i <= LOGMAX; i++) {
            if (!(x & (1 << i))) continue;
            for (int j = 0; j < i; j++) {
                if (!(x & (1 << j))) {
                    negace[i][j] = x;
                }
            }
        }
    }

    int mocnina = -1;
    vector<int> b;
    for (int x : a) {
        for (int i = mocnina + 1; i <= LOGMAX; i++) {
            if (!(x & (1 << i))) continue;
            for (int j = 0; j < i; j++) {
                if (!(x & (1 << j))) continue;
                if (!negace[i][j]) goto dalsi_i;
            }

            mocnina = i;
            b.clear();
            b.push_back(x);
            for (int j = 0; j < i; j++) {
                if (!(x & (1 << j))) continue;
                b.push_back(negace[i][j]);
            }

            dalsi_i: ;
        }
    }

    sort(b.begin(), b.end());
    b.erase(unique(b.begin(), b.end()), b.end());

    cout << b.size() << endl;
    for (int i = 0; i < (int) b.size(); i++) {
        if (i != 0) cout << " ";
        cout << b[i];
    }
    cout << endl;

    return 0;
}
